import sys
import os
import appuifw
import series60_console
import e32
from rusos import*

def query_and_exec():
    def is_py(x):
        return os.path.splitext(x)[1].lower() == '.py'

    my_script_dir = os.path.join(this_dir,'my')
    script_list = []

    if os.path.exists(my_script_dir):
        script_list = map(unicode,filter(is_py, os.listdir(my_script_dir)))

    index = appuifw.selection_list(map(unicode, script_list))
    if index >= 0:
        execfile(os.path.join(this_dir+'\\my\\', script_list[index]), globals())

def exec_interactive():
    import interactive_console
    interactive_console.Py_console(my_console).interactive_loop()

def exec_btconsole():
    import btconsole
    btconsole.main()

def menu_action(f):
    appuifw.app.menu = []
    saved_exit_key_handler = appuifw.app.exit_key_handler

    try:
        try:
            f()
        finally:
            appuifw.app.exit_key_handler = saved_exit_key_handler
            appuifw.app.title = u'Python'
            init_options_menu()
            appuifw.app.body = my_console.text
            appuifw.app.screen='normal'
            sys.stderr = sys.stdout = my_console
    except:
        import traceback
        traceback.print_exc()

def init_options_menu():
    appuifw.app.menu = [(ru("Скрипты"),\
                         lambda: menu_action(query_and_exec)),
                        (ru("Интерактив"),\
                         lambda: menu_action(exec_interactive)),\
                        (ru("Bluetooth консоль"),\
                         lambda: menu_action(exec_btconsole))]

this_dir = os.path.split(appuifw.app.full_name())[0]
my_console = series60_console.Console()
appuifw.app.body = my_console.text
sys.stderr = sys.stdout = my_console
#from e32 import _stdo
#_stdo(u'c:\\python_error.log')         # low-level error output
init_options_menu()
print ru('\nPython для серии 60\n\nSoftWare is\nCopyright (c) 2004 Nokia\n\nВерсия ')+e32.pys60_version+"\n\n"
